
/***************************************************************************
                 module classe bn2_rn2.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, Mars 18, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{/*		1	from	tb			1  i 	j    k    t-1
		2	from	tb			1  i 	j    k-1  t-1
		3	from	sb			1  i 	j    k    t-1
		4	from	sb			1  i 	j    k-1  t-1*/
  // ! Linear formulation function of temperature and salinity
  /*     norm(rn2Y-rn2F)=  2.337985278655729e-16
	 norm(rn2Y-rn2F)/norm(rn2F)= 6.756554094212413e-14
  */
  if(Yt==TU){
    YS1=0.;
  }
  else{
    if(Yk==0 || Yk==NZ-1)
      YS1=0.;
    else{
      double zgde3w = grav / fse3w(Yi,Yj,Yk) * tmask(Yi,Yj,Yk);
      YS1 = zgde3w*(ralpha*(x2-x1)-rbeta*(x4-x3));
    } 
  }
  //
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{
  YJ1I1=0.;     YJ1I2=0.;     YJ1I3=0.;  YJ1I4=0.; 
  if(Yt!=TU){
    if(Yk==0 || Yk==NZ-1){
      YJ1I1=0.;
      YJ1I2=0.;
      YJ1I3=0.;
      YJ1I4=0.; 
    }
    else{
      double zgde3w = grav / fse3w(Yi,Yj,Yk) * tmask(Yi,Yj,Yk);
      YJ1I1= -zgde3w*ralpha;
      YJ1I2=  zgde3w*ralpha;
      YJ1I3=  zgde3w*rbeta;
      YJ1I4= -zgde3w*rbeta; 
    } 
  }
  
}

//===========================================================================
//********************* FIN DU MODULE bn2_rn2 **********************

