
/***************************************************************************
                 module classe dta_lfil.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, July 21, 2011
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5,YREAL x6)
{ /*	1	from	nu      		1  i 	j    k
	2	from	dta_lfil		1  i 	j    k     t-1 
	3	from	ztuv_lfil		1  i-1 	j    k     t 
 	4	from	ztuv_lfil		1  i 	j    k     t
	5	from	ztuv_lfil		2  i 	j-1  k     t 
	6	from	ztuv_lfil		2  i 	j    k     t */
  //  if (Yi==5 && Yj==5)
  //printf("dta_lfil : %d\n",Yt);

  if(Yt==1){
    double zbtr = zbtr2(Yi,Yj);
    double wm12=sqrt(zbtr);//1./(106000.); //1/sqrt(ds1*ds2)
    YS1=wm12*x1;
  }
  else{
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YS1=0.;
    }
    else{
      double zbtr = zbtr2(Yi,Yj);
      YS1 =x2+ pdth_fil*zbtr*(x4- x3 + x6 - x5);
    }
  }
  //
  /*    if(Yt==1 && Yk==0 && Yi<26 && Yi>22 && Yj<17 && Yj>13) 
      printf("nul1(%d,%d) = %24.16e \n",Yi+1,Yj+1,YS1);
    if(Yt==40 && Yk==0 && Yi<26 && Yi>22 && Yj<17 && Yj>13) 
    printf("nul40(%d,%d) = %24.16e \n",Yi+1,Yj+1,YS1);*/
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5,YREAL x6)
{
  YJ1I1=0.;     YJ1I2=0.;    YJ1I3=0.;    YJ1I4=0.;    YJ1I5=0.;    YJ1I6=0.;


  if(Yt==1){
    double zbtr = zbtr2(Yi,Yj);
    double wm12=sqrt(zbtr);//(106000.); //1/sqrt(ds1*ds2)
    //    double wm12=1./(106000.); //1/sqrt(ds1*ds2)
    YJ1I1=wm12;
  }
  else{
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YJ1I1=0.;     YJ1I2=0.;    YJ1I3=0.;    YJ1I4=0.;    YJ1I5=0.;    YJ1I6=0.;
    }
    else{
      double zbtr = zbtr2(Yi,Yj);
      YJ1I1=0.;     YJ1I2=1.;    YJ1I3=-pdth_fil*zbtr;    
      YJ1I4=pdth_fil*zbtr;    YJ1I5=-pdth_fil*zbtr;    YJ1I6=pdth_fil*zbtr;
    }
  }
  //
  /*  if(Ycurward==BACKWARD){
    if(Yt==10 && Yk==0 && Yi<26 && Yi>22 && Yj<17 && Yj>13) 
      printf("YG_1L(%d,%d) = %24.16e \n",Yi+1,Yj+1,YG1);
  }*/
}
