
/***************************************************************************
                 module classe dta_zfilt.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, July 29, 2011
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{ /*	1	from	nu      		1  i 	j    k  
	2	from	dta_zfilt      		1  i 	j    k-1   t-1
	3	from	dta_zfilt		1  i 	j    k     t-1 
	4	from	dta_zfilt		1  i 	j    k+1   t-1 */

  if(Yt==1){
    double wm12=1./sqrt(fse3t(Yi,Yj,Yk)); //1/sqrt(dz)
    YS1=wm12*x1;
  }
  else{
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YS1=0.;
    }
    else{
      double ak =-avt_fil*pdtz_fil/fse3w(Yi,Yj,Yk) 
	,akp1=-avt_fil*pdtz_fil/fse3w(Yi,Yj,Yk+1);
      double tkm1, tk,tkp1;
      if(Yk==0){
#ifdef K_NEU
	tkm1= -ak* x3;
#else
	tkm1= 0.;
#endif
      }
      else
	tkm1= -ak* x2;
      tk=(fse3t(Yi,Yj,Yk) +akp1 +ak)*x3;
      if(Yk==NZ-2){
#ifdef K_NEU
        tkp1  = -akp1*x3;
#else
        tkp1= 0.;
#endif
      }
      else
        tkp1  = -akp1*x4;
      YS1 = (tkm1 + tk +tkp1)/fse3t(Yi,Yj,Yk);
    }
  }
  //
}
      
//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{
  YJ1I1=0.;     YJ1I2=0.; YJ1I3=0.;     YJ1I4=0.;

  if(Yt==1){
    double wm12=1./sqrt(fse3t(Yi,Yj,Yk)); //1/sqrt(dz)
    YJ1I1=wm12;
  }
  else{
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk==NZ-1){
      YJ1I1=0.;
    }
    else{
      double ak =-avt_fil*pdtz_fil/fse3w(Yi,Yj,Yk) 
	,akp1=-avt_fil*pdtz_fil/fse3w(Yi,Yj,Yk+1);
      double dtkm1_x2=0., dtk_x3=0.,dtkp1_x4=0.;
      double dtkm1_x3=0.,dtkp1_x3=0.;
      if(Yk==0){
#ifdef K_NEU
	dtkm1_x3= -ak;
#endif
      }
      else
	dtkm1_x2= -ak;

      dtk_x3=(fse3t(Yi,Yj,Yk) +akp1 +ak);
      if(Yk==NZ-2){
#ifdef K_NEU
        dtkp1_x3  = -akp1;
#endif
      }
      else
        dtkp1_x4  = -akp1;

      YJ1I1=0.;
      YJ1I2=dtkm1_x2/fse3t(Yi,Yj,Yk);
      YJ1I3=(dtkm1_x3 + dtk_x3 +dtkp1_x3)/fse3t(Yi,Yj,Yk);
      YJ1I4=dtkp1_x4/fse3t(Yi,Yj,Yk);
    }
  }
  //

}
