/***************************************************************************
                 module classe hdivn.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, April 27, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{ /*	1	from	ua			1  i 	j    k    t
	2	from	ua			1  i-1 	j    k    t
	3	from	va			1  i 	j    k    t
	4	from	va			1  i 	j-1  k    t*/
  if(Yt==TU){
    YS1=hdivn_at_TU(Yi,Yj,Yk);
    //    YS1=0.;
  }
  else{
    if(Yi==0 || Yj==0 || Yi==NX-1 || Yj==NY-1 || Yk==NZ-1)
      YS1=0.;
    else
      YS1= ( e2u(Yi,Yj) * x1 - e2u(Yi-1,Yj  ) * x2 + e1v(Yi,Yj) * x3 - e1v(Yi,Yj-1) * x4) / (e1t(Yi,Yj)*e2t(Yi,Yj));
  }
  //
}
//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{
  YJ1I1=0.;     YJ1I2=0.;    YJ1I3=0.;    YJ1I4=0.;
  
  if(Yt!=TU){
    if(Yi==0 || Yj==0 || Yi==NX-1 || Yj==NY-1 || Yk==NZ-1){
      YJ1I1=0.;     YJ1I2=0.;    YJ1I3=0.;    YJ1I4=0.;
    }
    else{
      YJ1I1=   e2u(Yi  ,Yj  )/ (e1t(Yi,Yj)*e2t(Yi,Yj));
      YJ1I2= - e2u(Yi-1,Yj  )/ (e1t(Yi,Yj)*e2t(Yi,Yj));
      YJ1I3=   e1v(Yi  ,Yj  )/ (e1t(Yi,Yj)*e2t(Yi,Yj));
      YJ1I4= - e1v(Yi  ,Yj-1)/ (e1t(Yi,Yj)*e2t(Yi,Yj));
    }
  }
  //
  
}

  //===========================================================================
//*************************  FIN DU MODULE hdivn   *************************

